//+------------------------------------------------------------------+
//|                                          VininI_Trend_WPR_MA.mq4 |
//|                                 opyright 2008. Victor Nicolaev  |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "opyright 2008. Victor Nicolaev"
#property link      "vinin@mail.ru"


#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow
#property indicator_level1 0
#property indicator_maximum 1
#property indicator_minimum -1

extern int WPR_Period=100;
extern int Trend_MA_Period=3;

extern int MA_Start=10;
extern int MA_Step=10;
extern int MA_Count=50;
extern int MA_Mode=0;
extern int Limit=1440;
extern bool AlertPossible    = true;
extern bool AlertOnlySound   = false;
extern bool SoundBuy  = true;
extern bool SoundSell = true;
extern string Sound          = "alert2.wav";
extern bool SendMailPossible = false;
extern int SIGNAL_BAR = 1;
//---- buffers
double Buffer[];
double WPR[];
double Trend[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//---- drawing settings
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Trend);
   SetIndexBuffer(1,WPR);
   SetIndexBuffer(0,Buffer);

   return(0); }//int init() 
   
//+------------------------------------------------------------------+
int start() {
   int limit;
   int counted_bars=IndicatorCounted();
   int i,j;
   double sum=0;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if (Limit>0) limit=MathMin(Limit,limit); 
   
   for (i = limit;i>=0;i--) WPR[i]=iWPR(NULL,0,WPR_Period,i);
   
   for (i = limit;i>=0;i--){
      sum=0;
      for (j=0;j<MA_Count;j++) 
         if (WPR[i]>iMAOnArray(WPR,0,MA_Start+j*MA_Step,0,MA_Mode,i)) sum+=1; else sum-=1;
      Buffer[i]=sum/MA_Count;
   }

   for (i = limit;i>=0;i--)Trend[i]=iMAOnArray(Buffer,0,Trend_MA_Period,0,MA_Mode,i);
   
static int  PrevTime = 0,PrevSignal = 0;
	  if(SIGNAL_BAR > 0 && Time[0] <= PrevTime) 
	      return(0);
	  PrevTime = Time[0];
     if (AlertPossible == true) {
	 if( SoundBuy==true){
	   if(PrevSignal >= 0){
        if( Trend[SIGNAL_BAR +1] > 0 && Trend[SIGNAL_BAR] < 0){
        if (AlertOnlySound) {PlaySound(Sound);} else {
            PrevSignal = -1;
            Alert("VininI_Trend_WPR_MA(", Symbol(), ", ", Period(), ")  -  SELL!!!");PlaySound(Sound);
            if (SendMailPossible) SendMail(Symbol()+ " M"+ Period()+ "  VininI_Trend_WPR_MA -  SELL!!!", "");
          }}}}
    if( SoundSell == true){
      if(PrevSignal <= 0){
        if(Trend[SIGNAL_BAR +1] < 0 && Trend[SIGNAL_BAR] > 0){
        if (AlertOnlySound) {PlaySound(Sound);} else {
            PrevSignal = 1;
            Alert(" VininI_Trend_WPR_MA(", Symbol(), ", ", Period(), ")  -  BUY!!!");PlaySound(Sound);
            if (SendMailPossible) SendMail(Symbol()+ " M"+ Period()+ "  VininI_Trend_WPR_MA  -  BUY!!!", "");
          }}}}}         
   return(0); 
}

   